#!/bin/sh
#ChangeVariables  -*- TCL -*- Created: ramsan Jan-1997, Modified: ramsan Jan-1997


#----------------------ChangeVariables ALONE---------------------------
# the next line restarts using wish \
	exec wish4.2 "$0" "$@"

#set ChangeVariablesRunningAlone 0
# catch {
#     if {$argv0 == [info script] } {
#         set ChangeVariablesRunningAlone 1
#         set tcl_interactive 0
#         set tk_strictMotif 1
	
#         if { [catch { set GIDDEFAULT $env(GIDDEFAULT)}]!=1 } {
#             set GIDDEFAULTTCL $GIDDEFAULT
#             catch { set GIDDEFAULTTCL $env(GIDDEFAULTTCL) }
#             set auto_path "$GIDDEFAULTTCL"
#             source $GIDDEFAULTTCL/init.tcl
#             source $GIDDEFAULTTCL/tk.tcl
#         }
#         wm withdraw .
#     }
# }

#  LOOK AT THE END OF THE FILE !!!
#-------------------------------------------------------------------

proc processBgColor {color fm} {
    
    set colorStr " "
    
    if {$fm == "gidToTcl"} {
	# Format RRR#GGG#BBB to #2x2x2x
	scan [string range $color 0 end] %3i%c%3i%c%3i col1 sp1 col2 sp2 col3
	set colorStr [format %c%02x%02x%02x $sp1 $col1 $col2 $col3]

    } elseif {$fm == "tclToGid"} {
	# Format #2x2x2x to RRR#GGG#BBB
	puts $color
	scan [string range $color 0 end] %c%2x%2x%2x sp1 col1 col2 col3
	
	puts $col1
	puts $col2 
	puts $col3
	set colorStr [format %03i%c%03i%c%03i $col1 $sp1 $col2 $sp1 $col3]
    }
    
    return $colorStr
}


proc DefineFuenteSiNoEsta { nombre_fnt} {
    if { [ lsearch [ font names] $nombre_fnt] == -1 } {
	#default: -adobe-helvetica-medium-r-normal--12-120-75-75-p-67-iso8859-1
	#Helvetica 12 normal roman
	font create $nombre_fnt
	set com_font [GiD_Set $nombre_fnt]
	# WarnWinText "$com_font"
	# WarnWinText "font conf CommentsFont [ font actual $com_font]"
	eval [ concat font conf $nombre_fnt [ font actual $com_font]]
	# ajustamos tamao
	if { [ regexp {^-[^-]*-[^-]*-[^-]*-[^-]*-[^-]*-[^-]*-([0-9]+)-[^-]*-[^-]*-[^-]*-[^-]*-[^-]*-[^-]*-[^-]*$} $com_font dum fnt_size]} {
	    font conf $nombre_fnt -size [ font metrics $com_font -ascent]
	}
    }
}

proc AcceptGiDFont { nombre_fnt} {
    global ChangeVarInfo GidPriv tcl_platform GIDDEFAULTTCL
    
    if { $tcl_platform(platform) != "windows" } {
	set wght [ font actual $nombre_fnt -weight]
	if { "$wght" == "normal"} { set wght medium}
	set slant [ string index [ font actual $nombre_fnt -slant] 0]
	set fnt_family [ font actual $nombre_fnt -family]
	#set fnt_size [ font actual $nombre_fnt -size]
	set fnt_size [ font metrics $nombre_fnt -ascent]
	set com_fnt "-*-$fnt_family-$wght-$slant-*-*-$fnt_size-*-*-*-*-*-*-*"
    } else {
	set com_fnt ""
	lappend com_fnt [ font actual $nombre_fnt -family]
	lappend com_fnt [ font actual $nombre_fnt -size]
	lappend com_fnt [ font actual $nombre_fnt -weight] 
	lappend com_fnt [ font actual $nombre_fnt -slant]
    }
    
    GiD_Set $nombre_fnt $com_fnt
}

proc AcceptAsianFont { nombre_fnt} {
    # WarnWinText "nombre_fnt = $nombre_fnt"
    # WarnWinText "::ChangeVarInfo(AsianFonts) = $::ChangeVarInfo(AsianFonts)"
    # WarnWinText "::ChangeVarInfo(AsianFont,family) = $::ChangeVarInfo(AsianFont,family)"
    # WarnWinText "::ChangeVarInfo(AsianFont,size) = $::ChangeVarInfo(AsianFont,size)"
    foreach ifnt $::ChangeVarInfo(AsianFonts) {
	set idioma [ lindex $ifnt 0]
	set nombre [ lindex $ifnt 1]
	#set estilo [ lindex $ifnt 2]
	#set tamanno_ant [ lindex $ifnt 3]
	#set txt "${idioma}: $nombre $estilo"
	set txt "${idioma}: $nombre"
	if { [ string equal $txt $nombre_fnt]} {
	    #WarnWinText "[ llength $ifnt] = $ifnt"
	    #GiD_Set AsianFont [ lreplace $ifnt 3 3 $::ChangeVarInfo(AsianFont,size)]
	    GiD_Set AsianFont $ifnt
	    break
	}
    }
}

proc AcceptPGFGiDFont { nombre_fnt} {
    #set idx $::ChangeVarInfo($nombre_fnt,texto)
    #set ident $::PGFFonts($idx)
    #set tam $::ChangeVarInfo($nombre_fnt,tamanno)
    #set ifnt "$ident $tam"

    set err [ 
	     catch {
		 set ifnt "$::PGFFonts($::ChangeVarInfo($nombre_fnt,texto)) $::ChangeVarInfo($nombre_fnt,tamanno)"
		 GiD_Set $nombre_fnt $ifnt
	     }]
    if { $err} {
	WarnWin [_ "Problems appeared when trying to set the new fonts.\nIf the language of the messages have been changed,\n it is recomended to restart the program."]
    }
    # set fuente_sel $::ChangeVarInfo($nombre_fnt,texto)
    # set idx [ lsearch $::PGFListaFuentes $fuente_sel]
    # if { $idx != -1} {
    # 	set info_fuente [ lindex [ lindex $::PGFInfoFuentes $idx] 0]
    # 	GiD_Set $nombre_fnt $info_fuente $::ChangeVarInfo($nombre_fnt,tamanno)
    # } else {
    # 	WarnWinText "Fuente no encontrada: '$fuente_sel'"
    # 	# WarnWinText "Lista fuentes:"
    # 	# foreach if $::PGFListaFuentes {
    # 	#     WarnWinText "\t$if"
    # 	# }
    # }
}

proc AcceptPGFModoRender { } {
    # GiD_Set PGF_ModoRender PGF_$::ChangeVarInfo(PGF_ModoRender,texto)
    GiD_Set PGF_ModoRender $::ChangeVarInfo(PGF_ModoRender,texto)
}

#change from GiD color varible style rrr#ggg#bbb (xxx from 0 to 255) 
#to Tk style #rrggbb hexadecimals
proc GiDColorToTkColor { colorgid } {
    scan $colorgid  %03d#%03d#%03d r g b
    return #[format %02x%02x%02x $r $g $b]
}

#change from Tk style color #rrggbb hexadecimals
#to GiD color varible style rrr#ggg#bbb (xxx from 0 to 255) 
proc TkColorToGiDColor { tkcolor } {
    scan $tkcolor #%2x%2x%2x r g b
    return [format %03d#%03d#%03d $r $g $b]
}

proc FillPrefValuesFromGid {} {
    global ChangeVarInfo GidPriv

    if { ![winfo exists .gid.wvar] } return

    if { ![ info exists ChangeVarInfo(type)]} return

    if { $ChangeVarInfo(type) == "GENERAL" } {

	set ChangeVarInfo(Dialogbrowser) [.central.s info variables DialogWrowser]

	set ChangeVarInfo(SplashWindow) [.central.s info variables SplashWindow]

	set input [.central.s info variables CreateAlwaysNewPoint]
	if { $input == 1 } { 
	    set ChangeVarInfo(Createnewpoint) Always
	} elseif { $input == 0 } { 
	    set ChangeVarInfo(Createnewpoint) Ask 
	} elseif { $input == -2 } { 
	    set ChangeVarInfo(Createnewpoint) Never
	} else {set ChangeVarInfo(Createnewpoint) No }

	set ChangeVarInfo(Displaycoordinates) \
		[.central.s info variables DisplayCoordinates]

	set input [.central.s info variables AutomaticRedraw]
	if { $input == 0 } {
	    set ChangeVarInfo(AutomaticRedraw) "None"
	} elseif { $input == 1 } { 
	    set ChangeVarInfo(AutomaticRedraw) "All windows" 
	} elseif { $input == 2 } {
	    set ChangeVarInfo(AutomaticRedraw) "Current window"
	} else { 
	    set ChangeVarInfo(AutomaticRedraw) "Current window" 
	}
	
	set input [.central.s info variables UseMoreWindows]
	if { $input == 1 } { 
	    set ChangeVarInfo(Usemorewindows) normal
	} elseif { $input == 2 } {
	    set ChangeVarInfo(Usemorewindows) beginner
	} else { 
	    #set ChangeVarInfo(Usemorewindows) no
	    set ChangeVarInfo(Usemorewindows) normal
	}

	set ChangeVarInfo(MaxNumOfRecentProjects) [GiD_Info variables MaxNumOfRecentProjects]
	set ChangeVarInfo(MaxNumOfRecentPostFiles) [GiD_Info variables MaxNumOfRecentPostFiles]
	set ChangeVarInfo(MaxNumOfRecentViewFiles) [GiD_Info variables MaxNumOfRecentViewFiles]
	set ChangeVarInfo(ReloadLastModel) [GiD_Info variables ReloadLastModel]
	set ChangeVarInfo(Sound) [GiD_Info variables Sound]
	set ChangeVarInfo(SmallWinSelecting) [GiD_Info variables SmallWinSelecting]

	set input [.central.s info variables BatchFileToWrite]
	if { $input == "UNKNOWN" } {
	    set ChangeVarInfo(WriteBatchCheck) 0
	    set ChangeVarInfo(WriteBatchFile) ""
	} else {
	    set ChangeVarInfo(WriteBatchCheck) 1
	    set ChangeVarInfo(WriteBatchFile) [lindex $input 0]
	}
	set ChangeVarInfo(WriteRotationsInBatch) \
		[.central.s info variables WriteRotationsInBatch]
	
	set input [.central.s info variables BackUpMinutes]
	set ChangeVarInfo(BackupTime) $input
	if { $input == 0 } {
	    set ChangeVarInfo(BackupCheck) 0
	} else {
	    set ChangeVarInfo(BackupCheck) 1
	}

	set ChangeVarInfo(Language) [::GidUtils::GetCurrentLanguage]

    } elseif { $ChangeVarInfo(type) == "GRAPH" } {

	set ChangeVarInfo(Lightsmoothedelements) \
		[.central.s info variables LightSmoothedElems]

	set ChangeVarInfo(AngleSmoothed) [format %g \
		[expr 57.295779513082323*acos([.central.s info variables \
		CosSmoothedElems])]]

	set input [.central.s info variables DrawSurfaceMode]
	switch $input {
	    0 { set ChangeVarInfo(DrawSurfaceMode) "None" }
	    1 { set ChangeVarInfo(DrawSurfaceMode) "Boundary lines" }
	    2 { set ChangeVarInfo(DrawSurfaceMode) "Isoparametric lines" }
	    3 { set ChangeVarInfo(DrawSurfaceMode) "Both modes" }
	}

	set ChangeVarInfo(DrawQuadratic) [GiD_Info variables DrawQuadraticElements]

	set ChangeVarInfo(LabelOptions) [GiD_Set LabelOptions]
	
	set ChangeVarInfo(CurvePrecision) \
		[.central.s info variables CurvePrecision]

	set ChangeVarInfo(SurfacePrecision) \
		[.central.s info variables SurfacePrecision]

	foreach i {BackgroundColor ColorPoints ColorLines ColorPolyLines \
		ColorSurfaces ColorSurfsIsoparametric ColorVolumes \
		ColorNodes ColorElements} {
	    set ChangeVarInfo($i) [GiDColorToTkColor [GiD_Set $i]]
	}

	set ChangeVarInfo(GUIAppearance) $GidPriv(GUIAppearance)
	set ChangeVarInfo(BackColorType) [ .central.s info variables BackColorType]
	ChangeColorEnableDisableWidgets
	set ChangeVarInfo(BackColorTop) [ .central.s info variables BackColorTop]
	set ChangeVarInfo(BackColorBottom) [ .central.s info variables BackColorBottom]
	ChangeColorFondoGiD BackColorTop 1
	ChangeColorFondoGiD BackColorBottom 1
	set ChangeVarInfo(BackColorSense) [ .central.s info variables BackColorSense]
	ChangeColorSenseFondoGiD $ChangeVarInfo(BackColorSense)
	
	set ChangeVarInfo(FastRotation) \
		[.central.s info variables FastRotation(Active)]
	if { $ChangeVarInfo(FastRotation) == "" } { set ChangeVarInfo(FastRotation) 0 }

	set ChangeVarInfo(AutomaticRotationCenter) \
	    [ .central.s info variables AutomaticRotationCenter]
	if { $ChangeVarInfo(AutomaticRotationCenter) == ""} { set ChangeVarInfo(AutomaticRotationCenter) 1}

	set ChangeVarInfo(FRPoints) \
		[.central.s info variables FastRotation(Points)]
	if { $ChangeVarInfo(FRPoints) == "" } { set ChangeVarInfo(FRPoints) 1 }
	
	set ChangeVarInfo(FRLines) \
		[.central.s info variables FastRotation(Lines)]
	if { $ChangeVarInfo(FRLines) == "" } { set ChangeVarInfo(FRLines) 1 }
	
	set ChangeVarInfo(FRSurfaces) \
		[.central.s info variables FastRotation(Surfaces)]
	if { $ChangeVarInfo(FRSurfaces) == "" } { set ChangeVarInfo(FRSurfaces) 1 }
	
	set ChangeVarInfo(FRVolumes) \
		[.central.s info variables FastRotation(Volumes)]
	if { $ChangeVarInfo(FRVolumes) == "" } { set ChangeVarInfo(FRVolumes) 1 }
	set ChangeVarInfo(AlwaysGeom) \
		[.central.s info variables FastRotation(UseAlwaysGeom)]
	
	set ChangeVarInfo(DrawGraphicObjects) \
		[.central.s info variables FastRotation(DrawGraphicObjects)]
	
	set ChangeVarInfo(FRCurvePrecision) \
		[.central.s info variables FastRotation(CurvePrecision)]
	if { $ChangeVarInfo(FRCurvePrecision) == "" } {
	    set ChangeVarInfo(FRCurvePrecision) 0.8
	}
	
    } elseif { $ChangeVarInfo(type) == "MESHING" } {

	set ChangeVarInfo(SizeTransitions) \
	    [.central.s info variables SizeTransitionsFactor]
	
	set ChangeVarInfo(BoundaryWeightedTransition) \
	    [.central.s info variables BoundaryWeightedTransition]
	
	set ChangeVarInfo(VolumeMesher) \
	    [.central.s info variables VolumeMesher]

	set ChangeVarInfo(MeshUntilEnd) \
	    [.central.s info variables MeshUntilEnd]
	
	set ChangeVarInfo(AvoidElementsInBoundary) \
	    [.central.s info variables AvoidElementsInBoundary]
	
	set ChangeVarInfo(SymmetricalStructuredTriangles) \
	    [.central.s info variables SymmetricalStructuredTriangles]
	
	set ChangeVarInfo(SymmetricalStructuredTetrahedra) \
	    [.central.s info variables SymmetricalStructuredTetrahedra]
	
	set ChangeVarInfo(AllowAutomaticStructured) \
	    [.central.s info variables AllowAutomaticStructured]

	set ChangeVarInfo(NoMeshFrozenLayers) \
		[.central.s info variables NoMeshFrozenLayers]

	set ChangeVarInfo(AutomaticCorrectSizes) \
		[.central.s info variables AutomaticCorrectSizes]

	set ChangeVarInfo(SurfaceMesher) \
		[.central.s info variables SurfaceMesher]

	set input [.central.s info variables ForceMeshEntities]
	if { $input & 1 } {
	    set ChangeVarInfo(ForceMeshPoints) 1
	} else {
	    set ChangeVarInfo(ForceMeshPoints) 0
	}
	if { $input & 2 } {
	    set ChangeVarInfo(ForceMeshLines) 1
	} else {
	    set ChangeVarInfo(ForceMeshLines) 0
	}
	if { $input & 4 } {
	    set ChangeVarInfo(ForceMeshSurfaces) 1
	} else {
	    set ChangeVarInfo(ForceMeshSurfaces) 0
	}
	
	set input [.central.s info variables HighQualitySmoothing]
	if { $input == 0 } { 
	    set ChangeVarInfo(HighQualitySmoothing) Normal
	} elseif { $input == 1 } { 
	    set ChangeVarInfo(HighQualitySmoothing) HighAngle
	} elseif { $input == 2 } { 
	    set ChangeVarInfo(HighQualitySmoothing) HighGeom
	} 
	#else {set ChangeVarInfo(HighQualitySmoothing) Normal }
	set ChangeVarInfo(Rjump,TakeCareCurvatures) \
	    [GiD_Set Rjump(TakeCareCurvatures)]
	
	set ChangeVarInfo(Rjump,TakeCareLayers) \
	    [GiD_Set Rjump(TakeCareLayers)]
	
	set ChangeVarInfo(Rjump,TangencyLimitAngle) \
	    [GiD_Set Rjump(TangencyLimitAngle)]
	
	set ChangeVarInfo(Rjump,IfRjumpFailsMeshSeparately) \
	    [GiD_Set Rjump(IfRjumpFailsMeshSeparately)]
	
	if { $::BOUNDARY_LAYER_MESH } {
	    set ChangeVarInfo(BoundaryLayer,GrowLaw) [GiD_Set BoundaryLayer(GrowLaw)]

	    set ChangeVarInfo(BoundaryLayer,GrowFactor) \
		    [format %.3g [GiD_Set BoundaryLayer(GrowFactor)]]
	    
	    set ChangeVarInfo(BoundaryLayer,AllowPrismaticElements) \
		    [GiD_Set BoundaryLayer(AllowPrismaticElements)]
	
	    set ChangeVarInfo(BoundaryLayer,MeshInSpecificLayer) \
		    [GiD_Set BoundaryLayer(MeshInSpecificLayer)]
	}
	
	set ChangeVarInfo(ChordalError,ApplyChordalErrorToModel) \
	    [GiD_Set ChordalError(ApplyChordalErrorToModel)]

	set x [GiD_Set ChordalError(RelativeChordalError)]
	set x [format "%.1f" $x]
	set ChangeVarInfo(ChordalError,RelativeChordalError) $x
	
	set ChangeVarInfo(TypeOfQuadMesher) \
	    [.central.s info variables TypeOfQuadMesher]
	
    } elseif { $ChangeVarInfo(type) == "EXCHANGE" } {

	set ChangeVarInfo(AutoCollapseAfterImport) \
		[.central.s info variables AutoCollapseAfterImport]

	set ChangeVarInfo(ImportTolerance) \
		[.central.s info variables ImportTolerance]

	set ChangeVarInfo(CollapseIgnoringLayers) \
		[.central.s info variables CollapseIgnoringLayers]

	set ChangeVarInfo(IGESIgnoreInvisible) \
		[.central.s info variables IGESIgnoreInvisible]

	set ChangeVarInfo(IGESSolidsManifoldBRep) \
		[.central.s info variables IGESSolidsManifoldBRep]

	set ChangeVarInfo(IGESCreateAllInLayerToUse) \
		[.central.s info variables IGESCreateAllInLayerToUse]

	set ChangeVarInfo(IGESCurveOnSurfaceFrom3D) \
		[.central.s info variables IGESCurveOnSurfaceFrom3D]

	set ChangeVarInfo(AutoImportTolerance) \
		[.central.s info variables AutoImportTolerance]

    } elseif { $ChangeVarInfo(type) == "FONTS" } {
	GidUtils::WaitState .gid

	# las fuentes de menus, ventanas, etc.
	if { ![info exists ChangeVarInfo(fontfamilies)] } {
	    set ChangeVarInfo(fontfamilies) [lsort [font families]]
	}   
	foreach i "NormalFont FixedFont BigFont" {
	    if { [$ChangeVarInfo($i,combo) cget -values] == "" } {
		set values ""
		foreach j $ChangeVarInfo(fontfamilies) {
		    if { $i == "FixedFont" && ![font metrics [list $j] -fixed] } {
		        continue 
		    }
		    lappend values $j
		}
		$ChangeVarInfo($i,combo) configure -values $values
	    }
	    foreach item {family size weight slant} {
		if { ![info exists ChangeVarInfo($i,$item)] || \
		         $ChangeVarInfo($i,$item) != [font conf $i -$item] } {
		    #if to avoid invoke traces
		    set ChangeVarInfo($i,$item) [font conf $i -$item]
		}
	    }
	}
	
	# ahora las dependientes de pre y post
	set modo [ lindex [ GiD_Info Project] 4]
	set esPost 0
	if { ( $modo eq "POSTUSE") || ( $modo eq "GRAFUSE")} {
	    set esPost 1
	}
	if { $esPost} {

	    #GidUtils::WaitState .gid
	    set lst_ttf_fonts [ GiD_PGF_Fonts get]
	    if { [ info exists ::PGFFonts]} { unset ::PGFFonts}
	    # if { [ info exists ::PGFListaFuentes]} { unset ::PGFListaFuentes}
	    # if { [ info exists ::PGFInfoFuentes]} { unset ::PGFInfoFuentes}
	    # set ::PGFListaFuentes {}
	    # set ::PGFInfoFuentes {}
	    foreach ifont $lst_ttf_fonts {
		set txt_combo [ join [ lindex $ifont 2] ", "]
		# tabla entrada_combo --> identificador = nombre_archivo + indice
		set ::PGFFonts($txt_combo) [ lrange $ifont 0 1]
		# lappend ::PGFListaFuentes $txt_combo
		# lappend ::PGFInfoFuentes [ list [ lrange $ifont 0 1]]
	    }
	    set lst_valores_combo [ lsort [ array names ::PGFFonts]]
	    #GidUtils::EndWaitState .gid
	    # foreach ifnt $lst_valores_combo {
	    # 	WarnWinText $ifnt
	    # }
	    set lst_fnts "PGF_DefaultFont PGF_AxisFont PGF_LegendFont PGF_LabelFont PGF_AsianFont PGF_TkDrawOGLFont"
	    foreach ifont $lst_fnts {
		$::ChangeVarInfo($ifont,combobox) configure -values $lst_valores_combo
		set info_fnt [ GiD_Info Variables $ifont]
		set ::ChangeVarInfo($ifont,texto) [ join [ lindex $info_fnt 3] ", "]
		set ::ChangeVarInfo($ifont,tamanno) [ lindex $info_fnt 2]
		set ::ChangeVarInfo($ifont,fuente) [ lrange $info_fnt 0 1]
	    }
	    # foreach ifnt [ $::ChangeVarInfo(PGF_DefaultFont,combobox) cget -values] {
	    # 	WarnWinText $ifnt
	    # }

	    # combobox normal:
	    #$::ChangeVarInfo(PGF_ModoRender,combobox) configure -values [ list Bitmap Pixmap]
	    # es una ComboBoxGiD
	    # set tipo_render [ GiD_Info Variables PGF_ModoRender]
	    # regsub {PGF_} $tipo_render {} ::ChangeVarInfo(PGF_ModoRender,texto)
	    $::ChangeVarInfo(PGF_ModoRender,combobox) configure \
		-keyvalues [ list PGF_Bitmap PGF_Pixmap] \
		-values [ list [_ "Sharp edges"] [_ "Smooth edges"]]
	    set ::ChangeVarInfo(PGF_ModoRender,texto) [ GiD_Info Variables PGF_ModoRender]
	    
	} else {
	    update idletasks
	    
	    #
	    foreach i "CommentsFont LabelsFont" {
		set values [GiD_Set $i]
		if { [llength $values] == 4 } {
		    foreach item {family size weight slant} value $values {
		        set ChangeVarInfo($i,$item) $value
		    }
		}
	    }
	    
	    # the Comments font
	    DefineFuenteSiNoEsta CommentsFont
	    DefineFuenteSiNoEsta LabelsFont
	    
	    foreach i "CommentsFont LabelsFont" {
		if { [$ChangeVarInfo($i,combo) cget -values] == "" } {
		    set values ""
		    foreach j $ChangeVarInfo(fontfamilies) {
		        if { $i == "FixedFont" && ![font metrics [list $j] -fixed] } {
		            continue 
		        }
		        lappend values $j
		    }
		    $ChangeVarInfo($i,combo) configure -values $values
		}
		foreach item {family size weight slant} {
		    if { ![info exists ChangeVarInfo($i,$item)] || \
		             $ChangeVarInfo($i,$item) != [font conf $i -$item] } {
		        #if to avoid invoke traces
		        set ChangeVarInfo($i,$item) [font conf $i -$item]
		    }
		}
	    }
	    
	    # para la fuente asiatica
	    if { [$ChangeVarInfo(AsianFont,combo) cget -values] == "" } {
		set lst_fnts [ lsort [ GiD_Fonts get AsianFonts]]
		set ChangeVarInfo(AsianFonts) $lst_fnts
		set values ""
		foreach ifnt $lst_fnts {
		    #lappend values "[ lindex $ifnt 0]: [ lindex $ifnt 1] [ lindex $ifnt 2]"
		    lappend values "[ lindex $ifnt 0]: [ lindex $ifnt 1]"
		}
		$ChangeVarInfo(AsianFont,combo) configure -values $values
	    }
	    
	    set cur_fnt [ GiD_Fonts get Current]
	    set idioma [ lindex $cur_fnt 0]
	    set nombre [ lindex $cur_fnt 1]
	    # set estilo [ lindex $cur_fnt 2]
	    #set ChangeVarInfo(AsianFont,family) "${idioma}: $nombre $estilo"
	    set ChangeVarInfo(AsianFont,family) "${idioma}: $nombre"
	    #set ChangeVarInfo(AsianFont,size) [ lindex $cur_fnt 3]
	}

	GidUtils::EndWaitState .gid
	    
    } elseif { $ChangeVarInfo(type) == "FORMAT" } {

	foreach fmt "PostLegendFormat PostScalarFormat PostVectorFormat PostMatrixFormat" {
	    set ChangeVarInfo($fmt) [ .central.s info variables $fmt]
	}

	set ChangeVarInfo(RealFormat,Default) $GidPriv(RealFormat,Default)

    } elseif { $ChangeVarInfo(type) == "GRID" } {
	set ChangeVarInfo(Grid,Show) [.central.s info variables Grid(Show)]
	set ChangeVarInfo(Grid,Active) [.central.s info variables Grid(Active)]
	set ChangeVarInfo(Grid,SpacingX) [.central.s info variables Grid(SpacingX)]
	set ChangeVarInfo(Grid,SpacingY) [.central.s info variables Grid(SpacingY)]        
	set ChangeVarInfo(Grid,MajorLineEvery) [.central.s info variables Grid(MajorLineEvery)]        
	set ChangeVarInfo(Grid,ExtentsX) [.central.s info variables Grid(ExtentsX)]
	set ChangeVarInfo(Grid,ExtentsY) [.central.s info variables Grid(ExtentsY)]
	set ChangeVarInfo(Grid,DrawAxis) [.central.s info variables Grid(DrawAxis)]
	set ChangeVarInfo(Grid,CenterX) [.central.s info variables Grid(CenterX)]
	set ChangeVarInfo(Grid,CenterY) [.central.s info variables Grid(CenterY)]
	set ChangeVarInfo(Grid,DrawLabels) [.central.s info variables Grid(DrawLabels)]
	ActualizaCaja x
	ActualizaCaja y
    } elseif { $ChangeVarInfo(type) == "POSTPROCESS" } {

	#foreach fmt "PostLegendFormat PostScalarFormat PostVectorFormat PostMatrixFormat" {
	#    set ChangeVarInfo($fmt) [ .central.s info variables $fmt]
	#}
	#
	#set GidPriv(RealFormat,Default) $GidPriv(RealFormat,Default)

    }
}


proc FillValuesDefault {} {
    global ChangeVarInfo

    if { $ChangeVarInfo(type) == "GENERAL" } {
	set ChangeVarInfo(Dialogbrowser) 1
	set ChangeVarInfo(SplashWindow) 1
	set ChangeVarInfo(ViewMenu) 1
	set ChangeVarInfo(Createnewpoint) Ask
	set ChangeVarInfo(Displaycoordinates) 1
	set ChangeVarInfo(AutomaticRedraw) "All windows"
	set ChangeVarInfo(Usemorewindows) yes
	set ChangeVarInfo(MaxNumOfRecentProjects) 5 
	set ChangeVarInfo(MaxNumOfRecentPostFiles) 8
	set ChangeVarInfo(MaxNumOfRecentViewFiles) 8
	set ChangeVarInfo(ReloadLastModel) 0
	set ChangeVarInfo(Sound) 0
	set ChangeVarInfo(SmallWinSelecting) 0
	set ChangeVarInfo(WriteBatchCheck) 0
	set ChangeVarInfo(WriteBatchFile) ""                        
	set ChangeVarInfo(BackupTime) 20
	set ChangeVarInfo(BackupCheck) 1
	set ChangeVarInfo(WriteRotationsInBatch) 0
	#is best to find the local language, not fix english
	set ChangeVarInfo(Language) "en"
    } elseif { $ChangeVarInfo(type) == "GRAPH" } {
	set ChangeVarInfo(Lightsmoothedelements) 1
	set ChangeVarInfo(AngleSmoothed) 40
	set ChangeVarInfo(DrawSurfaceMode) "Boundary lines"
	set ChangeVarInfo(DrawQuadratic) No
	set ChangeVarInfo(LabelOptions) 1
	set ChangeVarInfo(NLightingSubdiv) 8
	set ChangeVarInfo(CurvePrecision) 0.8
	set ChangeVarInfo(SurfacePrecision) 0.6
	set ChangeVarInfo(FastRotation) 0
	set ChangeVarInfo(AutomaticRotationCenter) 1
	
	set ChangeVarInfo(FRPoints) 1
	set ChangeVarInfo(FRLines) 1
	set ChangeVarInfo(FRSurfaces) 1 
	set ChangeVarInfo(FRVolumes) 1
	set ChangeVarInfo(AlwaysGeom) 0
	set ChangeVarInfo(FRCurvePrecision) 0.8
	set ChangeVarInfo(DrawGraphicObjects) 1
	set ChangeVarInfo(BackgroundColor) [GiDColorToTkColor [GiD_Info RGBDefaultBackground]]
	set ChangeVarInfo(ColorPoints) "#000000"
	set ChangeVarInfo(ColorLines) "#0000ff"
	set ChangeVarInfo(ColorPolyLines) "#5f8f2f"
	set ChangeVarInfo(ColorSurfaces) "#ff00ff"
	set ChangeVarInfo(ColorSurfsIsoparametric) "#ffff00"
	set ChangeVarInfo(ColorVolumes) "#00ffff"
	set ChangeVarInfo(ColorNodes) "#000000"
	set ChangeVarInfo(ColorElements) "#5f8f2f"
	# 1 color algo ms apagado 
	# 0 normal (color standard windows)
	set ChangeVarInfo(GUIAppearance) 1
	# 0: fondo normal y liso    1: fondo degradado entre dos colores
	set ChangeVarInfo(BackColorType) 0
	ChangeColorEnableDisableWidgets
	set ChangeVarInfo(BackColorTop) \#6699ff
	set ChangeVarInfo(BackColorBottom) \#cccc99
	ChangeColorFondoGiD BackColorTop 1
	ChangeColorFondoGiD BackColorBottom 1
	set ChangeVarInfo(BackColorSense) d
	ChangeColorSenseFondoGiD $ChangeVarInfo(BackColorSense)
    } elseif { $ChangeVarInfo(type) == "MESHING" } {
	
	set ChangeVarInfo(SizeTransitions) 0.6
	set ChangeVarInfo(BoundaryWeightedTransition) 1
	set ChangeVarInfo(SurfaceMesher) 0
	set ChangeVarInfo(VolumeMesher) 0
	set ChangeVarInfo(MeshUntilEnd) 1
	set ChangeVarInfo(SymmetricalStructuredTriangles) 1
	set ChangeVarInfo(SymmetricalStructuredTetrahedra) 1
	set ChangeVarInfo(AvoidElementsInBoundary) 0
	set ChangeVarInfo(AllowAutomaticStructured) 0
	set ChangeVarInfo(NoMeshFrozenLayers) 1
	set ChangeVarInfo(AutomaticCorrectSizes) 2
	set ChangeVarInfo(ForceMeshPoints) 0
	set ChangeVarInfo(ForceMeshLines) 0
	set ChangeVarInfo(ForceMeshSurfaces) 0
	set ChangeVarInfo(HighQualitySmoothing) Normal
	set ChangeVarInfo(Rjump,TakeCareCurvatures) 100.0
	set ChangeVarInfo(Rjump,TakeCareLayers) 0
	set ChangeVarInfo(Rjump,TangencyLimitAngle) 10.0
	set ChangeVarInfo(Rjump,IfRjumpFailsMeshSeparately) 1
	set ChangeVarInfo(ChordalError,ApplyChordalErrorToModel) 0
	set ChangeVarInfo(ChordalError,RelativeChordalError) 0.
	set ChangeVarInfo(TypeOfQuadMesher) 1    
	if { $::BOUNDARY_LAYER_MESH } {
	    set ChangeVarInfo(BoundaryLayer,GrowLaw) 0 
	    set ChangeVarInfo(BoundaryLayer,GrowFactor) 2. 
	    set ChangeVarInfo(BoundaryLayer,AllowPrismaticElements) 0 
	    set ChangeVarInfo(BoundaryLayer,MeshInSpecificLayer) 0     
	}

    } elseif { $ChangeVarInfo(type) == "EXCHANGE" } {
	
	set ChangeVarInfo(AutoCollapseAfterImport) 1
	set ChangeVarInfo(ImportTolerance) 1.0e-4
	set ChangeVarInfo(CollapseIgnoringLayers) 1
	set ChangeVarInfo(IGESIgnoreInvisible) 1
	set ChangeVarInfo(IGESSolidsManifoldBRep) 1
	set ChangeVarInfo(IGESCreateAllInLayerToUse) 0
	set ChangeVarInfo(IGESCurveOnSurfaceFrom3D) 1
	set ChangeVarInfo(AutoImportTolerance) 1

    }  elseif { $ChangeVarInfo(type) == "FONTS" } {
	font delete NormalFont FixedFont BoldFont BigFont SmallFont
	SetFontsDefault        

	# the Comments font
	#set com_font [ .central.s info variables CommentsFont]
	#lo anterior da el actual, no un valor por defecto!!
	set com_font {Helvetica 12}
	if { [ lsearch [ font names] CommentsFont] == -1 } {
	    font create CommentsFont
	}
	eval [ concat font conf CommentsFont [ font actual $com_font]]

	#set com_font [ .central.s info variables LabelsFont] ;
	#lo anterior da el actual, no un valor por defecto!!
	set com_font {FixedSys 8}
	if { [ lsearch [ font names] LabelsFont] == -1 } {
	    font create LabelsFont
	}
	eval [ concat font conf LabelsFont [ font actual $com_font]]

	foreach i "NormalFont FixedFont BigFont CommentsFont LabelsFont" {
	    foreach item {family size weight slant} {            
		set ChangeVarInfo($i,$item) [font conf $i -$item]
	    }
	}

	set cur_fnt [ GiD_Fonts get Current]
	set idioma [ lindex $cur_fnt 0]
	set nombre [ lindex $cur_fnt 1]
	#set estilo [ lindex $cur_fnt 2]
	#set ChangeVarInfo(AsianFont,family) "${idioma}: $nombre $estilo"
	set ChangeVarInfo(AsianFont,family) "${idioma}: $nombre"
	#set ChangeVarInfo(AsianFont,size) [ lindex $cur_fnt 3]

    } elseif { $ChangeVarInfo(type) == "FORMAT" } {
	set ChangeVarInfo(PostLegendFormat) "%.5g"
	set ChangeVarInfo(PostScalarFormat) "%.5g"
	set ChangeVarInfo(PostVectorFormat) "%.4g"
	set ChangeVarInfo(PostMatrixFormat) "%.4g"
	set ChangeVarInfo(RealFormat,Default) "%.4g"
    } elseif { $ChangeVarInfo(type) == "GRID" } {
	set ChangeVarInfo(Grid,Show) 0
	set ChangeVarInfo(Grid,Active) 0
	set ChangeVarInfo(Grid,SpacingX) 1.0
	set ChangeVarInfo(Grid,SpacingY) 1.0        
	set ChangeVarInfo(Grid,MajorLineEvery) 10
	set ChangeVarInfo(Grid,ExtentsX) 15.0
	set ChangeVarInfo(Grid,ExtentsY) 10.0
	set ChangeVarInfo(Grid,DrawAxis) 0
	set ChangeVarInfo(Grid,CenterX) 0.0
	set ChangeVarInfo(Grid,CenterY) 0.0
	set ChangeVarInfo(Grid,DrawLabels) 0
	ActualizaCaja x
	ActualizaCaja y
    } elseif { $ChangeVarInfo(type) == "POSTPROCESS" } {
	#set postprefs [.central.s info postprocess get results_options]
	#
	## the default values:
	#set postncols [ lindex $postprefs 0]
	#set ChangeVarInfo(NumColors) [ lindex $postncols 0]
	#set ChangeVarInfo(IntvWidth) [ lindex $postprefs 1]
	#set postcontlimits [ lindex $postprefs 2]
	#set ChangeVarInfo(ContourLimMin) [ lindex $postcontlimits 0]
	#set ChangeVarInfo(ContourLimMax) [ lindex $postcontlimits 1]
	#set postvoff [ lindex $postprefs 4]
	#set ChangeVarInfo(VectorOffset) [ lindex $postvoff 0]
	#
	#set borderangles [ join [ .central.s info postprocess get criterio_bordes]]
	#set ChangeVarInfo(BordeAngle) [ lindex $borderangles 0]
	#
	#set postvcols [ lindex $postprefs 6]
	#set ChangeVarInfo(VectNumColors) [ lindex $postvcols 0]
    }
}

proc UpdateWidgetsLanguage { } {
    global GidPriv
    .gid.phantom.display3dbutton delete 0 end ;#to re-create the 3rd button menu
    SetAllMenusVariables 
    #CreateTopMenus

    ChangeTopMenusAndWindows
    ChangeVariables
    if { [info exists GidPriv(InitWindowList)] } {
	foreach geomwinname $GidPriv(InitWindowList) {
	    if { [lsearch {PrePostTopMenuWindow} $geomwinname] != "-1" } {
		continue
	    }
	    if { [info exists GidPriv($geomwinname)] && [winfo exists $GidPriv($geomwinname)] } {
		catch { eval $GidPriv($geomwinname,InitComm) }
	    }
	}
    }
    #lower command
    if { [info exists GidPriv(PrePostEntryWindowGeom)] } {
	BottomEntryFrame [lindex $GidPriv(PrePostEntryWindowGeom) 0]
    }
    ChangeWindowTitle
    DWInitUserDataOptions
}       

proc AcceptValues { w } {
    global ChangeVarInfo GidPriv tcl_platform GIDDEFAULTTCL
    MakeNoise changesareaccepted
    set res ""
    
    if { ![info exists ChangeVarInfo(type)] } return

    if { $ChangeVarInfo(type) == "GENERAL" } {
	if { $ChangeVarInfo(WriteBatchCheck) == 1 && \
		$ChangeVarInfo(WriteBatchFile)  == "" } {
	    tk_dialogRAM $w.tempwin [_ "Error window"] \
		[_ "If batch file is on, one file name must be given"] error 0 [_ "OK"]
	    return
	}

	#activate trace function
	set ChangeVarInfo(BackupCheck) $ChangeVarInfo(BackupCheck) 

	if { $ChangeVarInfo(Dialogbrowser) != \
		[.central.s info variables DialogWrowser] } {
	    lappend res DialogWrowser $ChangeVarInfo(Dialogbrowser)
	}

	if { $ChangeVarInfo(SplashWindow) != \
		[.central.s info variables SplashWindow] } {
	    lappend res SplashWindow $ChangeVarInfo(SplashWindow)
	}

	switch $ChangeVarInfo(Createnewpoint) {
	    Always {
		set rr 1
	    }
	    Ask {
		set rr 0
	    }
	    Never {
		set rr -2
	    }
	    No { 
		set rr -1
	    }
	    default {
		# problems
		set rr -3 
	    }
	}
	if { $rr != [.central.s info variables CreateAlwaysNewPoint] } {
	    lappend res CreateAlwaysNewPoint $rr
	}
	if { $ChangeVarInfo(Displaycoordinates) != \
		[.central.s info variables DisplayCoordinates] } {
	    lappend res DisplayCoordinates $ChangeVarInfo(Displaycoordinates)
	    if { !$ChangeVarInfo(Displaycoordinates) } {
		pack forget .gid.comm.fcoord
	    } else {
		pack forget .gid.comm.fle
		pack forget .gid.comm.fwarn
		pack .gid.comm.fcoord -fill y -side right
		pack .gid.comm.fle -fill x -side bottom -expand yes -pady 2 -padx 2
		pack .gid.comm.fwarn -fill both -side top -expand yes
	    }
	}
	      
	switch $ChangeVarInfo(AutomaticRedraw) {
	    "All windows" {
		set rr 1 
	    }
	    "Current window" {
		set rr 2
	    }
	    "None" {
		set rr 0
	    }
	}
	if { $rr != [.central.s info variables AutomaticRedraw] } {
	    lappend res AutomaticRedraw $rr
	}

	switch $ChangeVarInfo(Usemorewindows) {
	    normal {
		set rr 1 
	    }
	    beginner {
		set rr 2
	    }
	    default {
		#set rr 0
		set rr 1
	    }
	}
	if { $rr != [.central.s info variables UseMoreWindows] } {
	    lappend res UseMoreWindows $rr
	}
	
	if { $ChangeVarInfo(MaxNumOfRecentProjects) != \
	    [ GiD_Info variables MaxNumOfRecentProjects] } {
	    lappend res MaxNumOfRecentProjects $ChangeVarInfo(MaxNumOfRecentProjects)
	}
	if { $ChangeVarInfo(MaxNumOfRecentPostFiles) != \
	    [ GiD_Info variables MaxNumOfRecentPostFiles] } {
	    lappend res MaxNumOfRecentPostFiles $ChangeVarInfo(MaxNumOfRecentPostFiles)
	}
	if { $ChangeVarInfo(MaxNumOfRecentViewFiles) != \
	    [ GiD_Info variables MaxNumOfRecentViewFiles] } {
	    lappend res MaxNumOfRecentViewFiles $ChangeVarInfo(MaxNumOfRecentViewFiles)
	}
	if { $ChangeVarInfo(ReloadLastModel) != \
	    [GiD_Info variables ReloadLastModel] } {
	    lappend res ReloadLastModel $ChangeVarInfo(ReloadLastModel)
	}
	if { $ChangeVarInfo(Sound) != \
	    [.central.s info variables Sound] } {
	    lappend res Sound $ChangeVarInfo(Sound)
	}
	if { $ChangeVarInfo(SmallWinSelecting) != \
	    [.central.s info variables SmallWinSelecting] } {
	    lappend res SmallWinSelecting $ChangeVarInfo(SmallWinSelecting)
	}
	
	regsub -all {\\} $ChangeVarInfo(WriteBatchFile) {/} \
		ChangeVarInfo(WriteBatchFile)

	set input [lindex [.central.s info variables BatchFileToWrite] 0]
	if { $input == "UNKNOWN" && $ChangeVarInfo(WriteBatchCheck)} {
	    lappend res BatchFileToWrite "\"$ChangeVarInfo(WriteBatchFile)\""
	} elseif { $input != "UNKNOWN" && !$ChangeVarInfo(WriteBatchCheck) } {
	    lappend res BatchFileToWrite UNKNOWN
	} elseif { $input != "UNKNOWN" && $ChangeVarInfo(WriteBatchCheck) && \
		$input != $ChangeVarInfo(WriteBatchFile) } {
	    lappend res BatchFileToWrite "\"$ChangeVarInfo(WriteBatchFile)\""
	}
     
	set input [.central.s info variables BackUpMinutes]
	if { $input != $ChangeVarInfo(BackupTime) } {
	    lappend res BackUpMinutes $ChangeVarInfo(BackupTime)
	}

	if { $ChangeVarInfo(WriteRotationsInBatch) != \
		[.central.s info variables WriteRotationsInBatch] } {
	    lappend res WriteRotationsInBatch $ChangeVarInfo(WriteRotationsInBatch)
	}
	
	if { $ChangeVarInfo(Language) != [::GidUtils::GetCurrentLanguage] } {
	    #WarnWin [_ "Must restart %s to use the new language" $GidPriv(ProgName)]
	    ::GidUtils::SetCurrentLanguage $ChangeVarInfo(Language) 1      
	    WarnWin [_ "Some problems may appear until the program is restarted."]
	}

    }

    if { $res != "" } {
	eval [concat .central.s process escape escape escape escape utilities variables \
		$res escape escape]
	set label [_ "General"]
	ChangeWarnLineVar [_ "Accepted new %s preferences" $label]
	set res ""
    }

    if { $ChangeVarInfo(type) == "GRAPH" } {

	if { $ChangeVarInfo(Lightsmoothedelements) != \
		[.central.s info variables LightSmoothedElems] } {
	    lappend res LightSmoothedElems $ChangeVarInfo(Lightsmoothedelements)
	}
	set CosAngleSmoothed [format %g [expr cos($ChangeVarInfo(AngleSmoothed)*\
		0.017453292519943295)]]
	set CosAngleSmoothedS [format %g [.central.s info variables CosSmoothedElems]]
	if { $CosAngleSmoothed != $CosAngleSmoothedS } {
	    lappend res CosSmoothedElems $CosAngleSmoothed
	}
	
	switch $ChangeVarInfo(DrawSurfaceMode) {
	    "None" { set var 0 }
	    "Boundary lines" { set var 1 }
	    "Isoparametric lines" { set var 2 }
	    "Both modes" { set var 3 }
	}
	if { [.central.s info variables DrawSurfaceMode] != $var } {
	    lappend res DrawSurfaceMode $var
	}

	if { $ChangeVarInfo(DrawQuadratic) != [.central.s info variables DrawQuadraticElements]} {
	    lappend res DrawQuadraticElements $ChangeVarInfo(DrawQuadratic)
	}

	if { $ChangeVarInfo(LabelOptions) != [GiD_Set LabelOptions]} {
	    lappend res LabelOptions $ChangeVarInfo(LabelOptions)
	}

	if { $ChangeVarInfo(CurvePrecision) != \
		[.central.s info variables CurvePrecision] } {
	    lappend res CurvePrecision $ChangeVarInfo(CurvePrecision)
	}

	if { $ChangeVarInfo(SurfacePrecision) != \
		[.central.s info variables SurfacePrecision] } {
	    lappend res SurfacePrecision $ChangeVarInfo(SurfacePrecision)
	}

	foreach i {BackgroundColor ColorPoints ColorLines ColorPolyLines \
		ColorSurfaces ColorSurfsIsoparametric ColorVolumes \
		ColorNodes ColorElements} {
	    set bgColor [TkColorToGiDColor $ChangeVarInfo($i)] 
	    if { $bgColor != [GiD_Set $i] } {
		lappend res $i $bgColor
	    }
	}

	if { $ChangeVarInfo(GUIAppearance) != $GidPriv(GUIAppearance) } {
	    if { $ChangeVarInfo(GUIAppearance) == 0 } {    
		WarnWin [_ "Must restart %s to update the change\
		         of GUI appearance to standard color" $GidPriv(ProgName)]
	    } else {
		WarnWin [_ "Must restart %s to update the change\
		        of GUI appearance to attenuated color" $GidPriv(ProgName)]
	    }
	    set GidPriv(GUIAppearance) $ChangeVarInfo(GUIAppearance)   
	}

	foreach bc "BackColorType BackColorTop BackColorBottom BackColorSense" {
	    if { $ChangeVarInfo($bc) != \
		     [.central.s info variables $bc] } {
		lappend res $bc $ChangeVarInfo($bc)
	    }
	}
	
	if { $ChangeVarInfo(FastRotation) != \
		[.central.s info variables FastRotation(Active)] } {
	    lappend res FastRotation(Active) $ChangeVarInfo(FastRotation)
	}
	if { $ChangeVarInfo(AutomaticRotationCenter) != \
		 [ .central.s info variables AutomaticRotationCenter] } {
	    lappend res AutomaticRotationCenter $ChangeVarInfo(AutomaticRotationCenter)
	}
	if { $ChangeVarInfo(FRPoints) != \
		[.central.s info variables FastRotation(Points)] } {
	    lappend res FastRotation(Points) $ChangeVarInfo(FRPoints)
	}
	if { $ChangeVarInfo(FRLines) != \
		[.central.s info variables FastRotation(Lines)] } {
	    lappend res FastRotation(Lines) $ChangeVarInfo(FRLines)
	}
	if { $ChangeVarInfo(FRSurfaces) != \
		[.central.s info variables FastRotation(Surfaces)] } {
	    lappend res FastRotation(Surfaces) $ChangeVarInfo(FRSurfaces)
	}
	if { $ChangeVarInfo(FRVolumes) != \
		[.central.s info variables FastRotation(Volumes)] } {
	    lappend res FastRotation(Volumes) $ChangeVarInfo(FRVolumes)
	}
	if { [.central.s info variables FastRotation(CurvePrecision)] != "" && \
		$ChangeVarInfo(FRCurvePrecision) != \
		[.central.s info variables FastRotation(CurvePrecision)] } {
	    lappend res FastRotation(CurvePrecision) $ChangeVarInfo(FRCurvePrecision)
	}
	if { $ChangeVarInfo(AlwaysGeom) != \
		[.central.s info variables FastRotation(UseAlwaysGeom)] } {
	    lappend res FastRotation(UseAlwaysGeom) $ChangeVarInfo(AlwaysGeom)
	}
	if { $ChangeVarInfo(DrawGraphicObjects) != \
		[.central.s info variables FastRotation(DrawGraphicObjects)] } {
	    lappend res FastRotation(DrawGraphicObjects) $ChangeVarInfo(DrawGraphicObjects)
	}
    }
    
    if { $res != "" } {
	eval [concat .central.s process escape escape escape escape utilities variables \
		$res escape escape]
	set label [_ "Graphical"]
	ChangeWarnLineVar [_ "Accepted new %s preferences" $label]
	set res ""
    }

    if { ![info exists ChangeVarInfo(type)] } return

    if { $ChangeVarInfo(type) == "MESHING" } {

	if { $ChangeVarInfo(SizeTransitions) != \
		[.central.s info variables SizeTransitionsFactor] } {
	    lappend res SizeTransitionsFactor $ChangeVarInfo(SizeTransitions)
	}
	
	if { $ChangeVarInfo(BoundaryWeightedTransition) != \
	    [.central.s info variables BoundaryWeightedTransition] } {
	    lappend res BoundaryWeightedTransition $ChangeVarInfo(BoundaryWeightedTransition)
	}

	if { $ChangeVarInfo(SurfaceMesher) != \
		[.central.s info variables SurfaceMesher] } {
	    lappend res SurfaceMesher $ChangeVarInfo(SurfaceMesher)
	}

	if { $ChangeVarInfo(VolumeMesher) != \
		[.central.s info variables VolumeMesher] } {
	    lappend res VolumeMesher $ChangeVarInfo(VolumeMesher)
	}
	
	if { $ChangeVarInfo(MeshUntilEnd) != \
		[.central.s info variables MeshUntilEnd] } {
	    lappend res MeshUntilEnd $ChangeVarInfo(MeshUntilEnd)
	}
	if { $ChangeVarInfo(SymmetricalStructuredTriangles) != \
	    [.central.s info variables SymmetricalStructuredTriangles] } {
	    lappend res SymmetricalStructuredTriangles $ChangeVarInfo(SymmetricalStructuredTriangles)
	}
	if { $ChangeVarInfo(AvoidElementsInBoundary) != \
	    [.central.s info variables AvoidElementsInBoundary] } {
	    lappend res AvoidElementsInBoundary $ChangeVarInfo(AvoidElementsInBoundary)
	}
	if { $ChangeVarInfo(SymmetricalStructuredTetrahedra) != \
	    [.central.s info variables SymmetricalStructuredTetrahedra] } {
	    lappend res SymmetricalStructuredTetrahedra $ChangeVarInfo(SymmetricalStructuredTetrahedra)
	}
	if { $ChangeVarInfo(AllowAutomaticStructured) != \
	    [.central.s info variables AllowAutomaticStructured] } {
	    lappend res AllowAutomaticStructured $ChangeVarInfo(AllowAutomaticStructured)
	}

	if { $ChangeVarInfo(NoMeshFrozenLayers) != \
		[.central.s info variables NoMeshFrozenLayers] } {
	    lappend res NoMeshFrozenLayers $ChangeVarInfo(NoMeshFrozenLayers)
	}
	
	if { $ChangeVarInfo(AutomaticCorrectSizes) != \
	    [.central.s info variables AutomaticCorrectSizes] } {
	    lappend res AutomaticCorrectSizes $ChangeVarInfo(AutomaticCorrectSizes)
	}
	set ForceMeshEntities 0
	if { $ChangeVarInfo(ForceMeshPoints) } {
	    set ForceMeshEntities [expr $ForceMeshEntities +1]
	}
	if { $ChangeVarInfo(ForceMeshLines) } {
	    set ForceMeshEntities [expr $ForceMeshEntities +2]
	}
	if { $ChangeVarInfo(ForceMeshSurfaces) } {
	    set ForceMeshEntities [expr $ForceMeshEntities +4]
	}
	if { $ForceMeshEntities != \
	    [.central.s info variables ForceMeshEntities] } {
	    lappend res ForceMeshEntities $ForceMeshEntities
	}
	
	if { $ChangeVarInfo(HighQualitySmoothing)=="Normal" } {
	    set HighQualitySmoothing 0
	} elseif { $ChangeVarInfo(HighQualitySmoothing)=="HighAngle" } {
	    set HighQualitySmoothing 1
	} else {
	    set HighQualitySmoothing 2
	}
	if { $HighQualitySmoothing != [GiD_Set HighQualitySmoothing] } {
	    lappend res HighQualitySmoothing $HighQualitySmoothing
	}

	if { $ChangeVarInfo(Rjump,TakeCareCurvatures) != [GiD_Set Rjump(TakeCareCurvatures)] } {
	    lappend res Rjump(TakeCareCurvatures) $ChangeVarInfo(Rjump,TakeCareCurvatures)
	}
	if { $ChangeVarInfo(Rjump,TakeCareLayers) != [GiD_Set Rjump(TakeCareLayers)] } {
	    lappend res Rjump(TakeCareLayers) $ChangeVarInfo(Rjump,TakeCareLayers)
	}
	if { $ChangeVarInfo(Rjump,TangencyLimitAngle) != [GiD_Set Rjump(TangencyLimitAngle)] } {
	    lappend res Rjump(TangencyLimitAngle) $ChangeVarInfo(Rjump,TangencyLimitAngle)
	}
	if { $ChangeVarInfo(Rjump,IfRjumpFailsMeshSeparately) != [GiD_Set Rjump(IfRjumpFailsMeshSeparately)] } {
	    lappend res Rjump(IfRjumpFailsMeshSeparately) $ChangeVarInfo(Rjump,IfRjumpFailsMeshSeparately)
	}
	if { $::BOUNDARY_LAYER_MESH } {
	    if { $ChangeVarInfo(BoundaryLayer,GrowLaw) != [GiD_Set BoundaryLayer(GrowLaw)] } {
		lappend res BoundaryLayer(GrowLaw) $ChangeVarInfo(BoundaryLayer,GrowLaw)
	    }
	    if { $ChangeVarInfo(BoundaryLayer,GrowFactor) != [GiD_Set BoundaryLayer(GrowFactor)] } {
		lappend res BoundaryLayer(GrowFactor) $ChangeVarInfo(BoundaryLayer,GrowFactor)
	    }
	    if { $ChangeVarInfo(BoundaryLayer,AllowPrismaticElements) != [GiD_Set BoundaryLayer(AllowPrismaticElements)] } {
		lappend res BoundaryLayer(AllowPrismaticElements) $ChangeVarInfo(BoundaryLayer,AllowPrismaticElements)
	    }
	    if { $ChangeVarInfo(BoundaryLayer,MeshInSpecificLayer) != [GiD_Set BoundaryLayer(MeshInSpecificLayer)] } {
		lappend res BoundaryLayer(MeshInSpecificLayer) $ChangeVarInfo(BoundaryLayer,MeshInSpecificLayer)
	    }
	}
	if { $ChangeVarInfo(ChordalError,ApplyChordalErrorToModel) != [GiD_Set ChordalError(ApplyChordalErrorToModel)] } {
	    lappend res ChordalError(ApplyChordalErrorToModel) $ChangeVarInfo(ChordalError,ApplyChordalErrorToModel)
	}
	if { $ChangeVarInfo(ChordalError,RelativeChordalError) != [GiD_Set ChordalError(RelativeChordalError)] } {
	    lappend res ChordalError(RelativeChordalError) $ChangeVarInfo(ChordalError,RelativeChordalError)
	}

	if { $ChangeVarInfo(TypeOfQuadMesher) != \
	    [.central.s info variables TypeOfQuadMesher] } {
	    lappend res TypeOfQuadMesher $ChangeVarInfo(TypeOfQuadMesher)
	}

	if { $res != "" } {
	    eval [concat .central.s process escape escape escape escape utilities \
		    variables $res escape escape]
	    set label [_ "Meshing"]
	    ChangeWarnLineVar [_ "Accepted new %s preferences" $label]
	    set res ""
	}
    }

    set res ""
    if { $ChangeVarInfo(type) == "EXCHANGE" } {

	if { $ChangeVarInfo(AutoCollapseAfterImport) != \
		[GiD_Set AutoCollapseAfterImport] } {
	    lappend res AutoCollapseAfterImport $ChangeVarInfo(AutoCollapseAfterImport)
	}

	if { $ChangeVarInfo(ImportTolerance) != \
		[GiD_Set ImportTolerance] } {
	    lappend res ImportTolerance $ChangeVarInfo(ImportTolerance)
	}

	if { $ChangeVarInfo(CollapseIgnoringLayers) != \
		[GiD_Set CollapseIgnoringLayers] } {
	    lappend res CollapseIgnoringLayers $ChangeVarInfo(CollapseIgnoringLayers)
	}

	if { $ChangeVarInfo(IGESIgnoreInvisible) != \
		[GiD_Set IGESIgnoreInvisible] } {
	    lappend res IGESIgnoreInvisible $ChangeVarInfo(IGESIgnoreInvisible)
	}

	if { $ChangeVarInfo(IGESSolidsManifoldBRep) != \
		[GiD_Set IGESSolidsManifoldBRep] } {
	    lappend res IGESSolidsManifoldBRep $ChangeVarInfo(IGESSolidsManifoldBRep)
	}

	if { $ChangeVarInfo(IGESCreateAllInLayerToUse) != \
		[GiD_Set IGESCreateAllInLayerToUse] } {
	    lappend res IGESCreateAllInLayerToUse $ChangeVarInfo(IGESCreateAllInLayerToUse)
	}

	if { $ChangeVarInfo(IGESCurveOnSurfaceFrom3D) != \
		[GiD_Set IGESCurveOnSurfaceFrom3D] } {
	    lappend res IGESCurveOnSurfaceFrom3D $ChangeVarInfo(IGESCurveOnSurfaceFrom3D)
	}

	if { $ChangeVarInfo(AutoImportTolerance) != \
		[GiD_Set AutoImportTolerance] } {
	    lappend res AutoImportTolerance $ChangeVarInfo(AutoImportTolerance)
	}

	if { $res != "" } {
	    eval [concat .central.s process escape escape escape escape utilities \
		    variables $res escape escape]
	    set label [_ "Import"]
	    ChangeWarnLineVar [_ "Accepted new %s preferences" $label]
	    set res ""
	}
    }
    if { $ChangeVarInfo(type) == "FONTS" } {
	# las fuentes de menus, ventanas, etc.
	foreach i "NormalFont FixedFont BigFont BoldFont" {
	    set fv $i
	    if { $i == "BoldFont" } {
		set fv NormalFont
		set weight bold
	    } else { 
		set weight $ChangeVarInfo($fv,weight) 
	    }
	    font configure $i -family $ChangeVarInfo($fv,family) \
		-size $ChangeVarInfo($fv,size) \
		-weight $weight \
		-slant $ChangeVarInfo($fv,slant)
	}
	
	# ahora las dependientes de pre y post
	set modo [ lindex [ GiD_Info Project] 4]
	set esPost 0
	if { ( $modo eq "POSTUSE") || ( $modo eq "GRAFUSE")} {
	    set esPost 1
	}
	if { $esPost} {
	    set lst_fnts "PGF_DefaultFont PGF_AxisFont PGF_LegendFont PGF_LabelFont PGF_AsianFont PGF_TkDrawOGLFont"
	    foreach if $lst_fnts {
		AcceptPGFGiDFont $if
	    }
	    AcceptPGFModoRender
	} else {
	    foreach i "CommentsFont LabelsFont" {
		set fv $i
		if { $i == "BoldFont" } {
		    set fv NormalFont
		    set weight bold
		} else { 
		    set weight $ChangeVarInfo($fv,weight) 
		}
		font configure $i -family $ChangeVarInfo($fv,family) \
		    -size $ChangeVarInfo($fv,size) \
		    -weight $weight \
		    -slant $ChangeVarInfo($fv,slant)
	    }
	    
	    AcceptGiDFont CommentsFont
	    AcceptGiDFont LabelsFont
	    # WarnWin "AcceptAsianFont $ChangeVarInfo(AsianFont,family)"
	    AcceptAsianFont $ChangeVarInfo(AsianFont,family)
	}
    }
    set res ""
    if { $ChangeVarInfo(type) == "FORMAT" } {
	set formatchanges 0
	foreach fmt "PostLegendFormat PostScalarFormat PostVectorFormat PostMatrixFormat" {
	    if { $ChangeVarInfo($fmt) != [GiD_Info variables $fmt]} {
		GiD_Process escape escape escape escape utilities variables $fmt \
		        $ChangeVarInfo($fmt) escape escape escape escape
		set formatchanges 1
	    }
	}

	if { $GidPriv(RealFormat,Default) != $ChangeVarInfo(RealFormat,Default) } {
	    set GidPriv(RealFormat,Default) $ChangeVarInfo(RealFormat,Default)
	    set formatchanges 1
	}

	if { $formatchanges } {
	    set label [_ "Format"]
	    ChangeWarnLineVar [_ "Accepted new %s preferences" $label]
	}

    }
    set res ""
    if { $ChangeVarInfo(type) == "GRID" } {
	if { $ChangeVarInfo(Grid,Show) != [.central.s info variables Grid(Show)] } {
	    lappend res Grid(Show) $ChangeVarInfo(Grid,Show)
	    set ::GidPriv(Grid,Show) $ChangeVarInfo(Grid,Show) ;#to update button and redraw
	}
	if { $ChangeVarInfo(Grid,Active) != [.central.s info variables Grid(Active)] } {
	    lappend res Grid(Active) $ChangeVarInfo(Grid,Active)
	    set ::GidPriv(Grid,Active) $ChangeVarInfo(Grid,Active) ;#to update button
	}
	if { $ChangeVarInfo(Grid,SpacingX) != [.central.s info variables Grid(SpacingX)] } {
	    lappend res Grid(SpacingX) $ChangeVarInfo(Grid,SpacingX)
	}
	if { $ChangeVarInfo(Grid,SpacingY) != [.central.s info variables Grid(SpacingY)] } {
	    lappend res Grid(SpacingY) $ChangeVarInfo(Grid,SpacingY)
	}
	if { $ChangeVarInfo(Grid,MajorLineEvery) != [.central.s info variables Grid(MajorLineEvery)] } {
	    lappend res Grid(MajorLineEvery) $ChangeVarInfo(Grid,MajorLineEvery)
	}
	if { $ChangeVarInfo(Grid,ExtentsX) != [.central.s info variables Grid(ExtentsX)] } {
	    lappend res Grid(ExtentsX) $ChangeVarInfo(Grid,ExtentsX)
	}
	if { $ChangeVarInfo(Grid,ExtentsY) != [.central.s info variables Grid(ExtentsY)] } {
	    lappend res Grid(ExtentsY) $ChangeVarInfo(Grid,ExtentsY)
	}
	if { $ChangeVarInfo(Grid,DrawAxis) != [.central.s info variables Grid(DrawAxis)] } {
	    lappend res Grid(DrawAxis) $ChangeVarInfo(Grid,DrawAxis)
	}
	if { $ChangeVarInfo(Grid,CenterX) != [.central.s info variables Grid(CenterX)] } {
	    lappend res Grid(CenterX) $ChangeVarInfo(Grid,CenterX)
	}
	if { $ChangeVarInfo(Grid,CenterY) != [.central.s info variables Grid(CenterY)] } {
	    lappend res Grid(CenterY) $ChangeVarInfo(Grid,CenterY)
	}
	if { $ChangeVarInfo(Grid,DrawLabels) != [.central.s info variables Grid(DrawLabels)] } {
	    lappend res Grid(DrawLabels) $ChangeVarInfo(Grid,DrawLabels)
	}
	if { $res != "" } {
	    eval [concat .central.s process escape escape escape escape utilities \
		    variables $res escape escape]
	    set label [_ "Grid"]
	    ChangeWarnLineVar [_ "Accepted new %s preferences" $label]
	    set res ""
	}
    }

    set res ""
    if { $ChangeVarInfo(type) == "POSTPROCESS" } {

	#set AreWeInPost [ .central.s info postprocess arewein ]
	#if { $AreWeInPost == "NO" } {
	#    tk_dialogRAM $w.err [_ "error"] \
	#             [_ "These options only work inside the PostProcess section!"] error 0 [_ "OK"]
	#}

    }
    if { $res != "" } {
	eval [concat .central.s process escape escape escape escape results $res \
		escape escape]
	set label [_ "Postprocess"]
	ChangeWarnLineVar [_ "Accepted new %s preferences" $label]
	set res ""
    }
}


proc DynamicPrecision { val } {
    .central.s process escape escape escape escape utilities variables \
	    CurvePrecision $val escape
#    .central.s makecurrent
#    .central.s process redraw
    .central.s render
}

proc ChangeToPrefType { w name } {
    global ChangeVarInfo GidPriv
    $w conf -cursor watch
    update
    switch $name {
	General {
	    set ChangeVarInfo(type) GENERAL
	}
	Graphical { 
	    set ChangeVarInfo(type) GRAPH
	}
	Meshing { 
	    set ChangeVarInfo(type) MESHING
	}
	Exchange { 
	    set ChangeVarInfo(type) EXCHANGE
	}
	Fonts { 
	    set ChangeVarInfo(type) FONTS
	}
	Format {
	    set ChangeVarInfo(type) FORMAT     
	}
	Grid {
	    set ChangeVarInfo(type) GRID     
	}
	Postprocess {
	    set ChangeVarInfo(type) POSTPROCESS

	    #get_all_post_limits            
	}
    }
    FillPrefValuesFromGid
    $w conf -cursor ""
    set GidPriv(CurrentPreference) $name
}

proc get_all_post_limits { } {
    global ChangeVarInfo

    set postprefs [.central.s info postprocess get results_options]

    set postncols [ lindex $postprefs 0]
    set ChangeVarInfo(MinColors) [ lindex $postncols 1]
#    set ChangeVarInfo(MaxColors) [ lindex $postncols 2]

    set postconttype [ lindex $postprefs 3]
    set ChangeVarInfo(ContourAllTypes) "[ lindex $postconttype 1] [ lindex $postconttype 2]"

    set postvoff [ lindex $postprefs 4]
    set ChangeVarInfo(MinVectorOffset) [ lindex $postvoff 1]
    set ChangeVarInfo(MaxVectorOffset) [ lindex $postvoff 2]

    set postvcol [ lindex $postprefs 5]
    set ChangeVarInfo(VectorAllColors) "[ lindex $postvcol 1] [ lindex $postvcol 2]"

    set base $ChangeVarInfo(BasePostWin) 
    set existPost [ lindex [.central.s info Project] 7]
    
    set borderangles [ join [ .central.s info postprocess get criterio_bordes]]
    set ChangeVarInfo(BordeAngleMin) [ lindex $borderangles 1]                
    set ChangeVarInfo(BordeAngleMax) [ lindex $borderangles 2]                
    
    set postvcols [ lindex $postprefs 6]
    set ChangeVarInfo(VectMinColors) [ lindex $postvcols 1]
#    set ChangeVarInfo(VectMaxColors) [ lindex $postvcols 2]
   
}

#
# ChangeVariables
#



source $GIDDEFAULTTCL/pref_general.ui.tcl
source $GIDDEFAULTTCL/pref_graphical.ui.tcl
source $GIDDEFAULTTCL/pref_format.ui.tcl
source $GIDDEFAULTTCL/pref_meshing.ui.tcl
source $GIDDEFAULTTCL/pref_import.ui.tcl
source $GIDDEFAULTTCL/pref_fonts_ui.tcl
source $GIDDEFAULTTCL/pref_grid.ui.tcl
#source $GIDDEFAULTTCL/pref_postprocess.ui.tcl

#curpref can be: General Graphical Meshing Exchange Fonts  Format Grid or Postprocess
proc ChangeVariables { { w .gid.wvar } {curpref ""} } {
    global GidPriv

    set existPost [ lindex [.central.s info Project] 7]

    InitWindow $w [_ "Preferences"] ChangeVariablesWindowGeom ChangeVariables
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
	    
    wm withdraw $w

    if { $curpref == "" } {
	if { [info exists GidPriv(CurrentPreference)] } {
	    set curpref $GidPriv(CurrentPreference)
	} else {
	    set curpref General
	}
    }

    frame $w.buts -bg [CCColorActivo [$w cget -background]]
    button $w.buts.ok -text [_ "Accept"] -command "AcceptValues $w" -underline 0
    button $w.buts.rs -text [_ "Reset"] -command FillValuesDefault -underline 0
    button $w.buts.cn -text [_ "Close"] -command "destroy $w" -underline 0

    SetWidgetsWidthFromText $w.buts.ok $w.buts.rs $w.buts.cn

    #pack $w.buts.ok $w.buts.rs $w.buts.cn -side left -padx 5 -ipadx 5 -pady 5
    grid $w.buts.ok -row 0 -column 0 -padx 5 -pady 5
    grid $w.buts.rs -row 0 -column 1 -padx 5 -pady 5
    grid $w.buts.cn -row 0 -column 2 -padx 5 -pady 5

    GidHelp $w.buts.ok [_ "With this button, changed values of the active tab are\
    accepted. If this button is not pressed, values changed by the user are not\
    computed."]
    GidHelp $w.buts.rs [_ "This button sets all the options of the active tab to its\
	    default values."]
    GidHelp $w.buts.cn [_ "This button closes the window without accepting any changed\
	    value. Press 'Accept' not to loose the changed options."]

    focus $w.buts.ok

    frame $w.f
    grid $w.buts -row 1 -column 0 -sticky nsew
    if { $::tcl_version >= 8.5 } { grid anchor $w.buts center }
    grid $w.f -row 0 -column 0 -sticky nsew
    grid rowconfigure $w.f 0 -weight 1
    grid columnconfigure $w.f 0 -weight 1
    grid rowconfigure $w 0 -weight 1
    grid columnconfigure $w 0 -weight 1

    set commands "pref_general_ui pref_graphical_ui pref_meshing_ui \
	    pref_exchange_ui pref_fonts_ui pref_format_ui pref_grid_ui "
    set names { "General" "Graphical" "Meshing" "Exchange" "Fonts" "Format" "Grid"}
    set labels [list [_ "General"]  [_ "Graphical"]  [_ "Meshing"]  \
	    [_ "Exchange"]  [_ "Fonts"] [_ "Format"] [_ "Grid"]]

    set def_back [$w cget -background]
    NoteBook $w.f.nb -internalborderwidth 0 -activebackground [CCColorActivo $def_back]
    foreach command $commands name $names label $labels {
	$command [$w.f.nb insert end $name -text $label]
    }
    pack $w.f.nb -fill both -expand yes

    $w.f.nb bindtabs <1> [list ChangeToPrefType $w]

    update idletasks

    ChangeToPrefType $w $curpref
    $w.f.nb raise $curpref

    wm deicon $w

    bind $w <Escape> "tkButtonInvoke $w.buts.cn"
    bind $w <Alt-a>  "tkButtonInvoke $w.buts.ok"
    bind $w <Alt-r>  "tkButtonInvoke $w.buts.rs"
    bind $w <Alt-c>  "tkButtonInvoke $w.buts.cn ; break"

    bind $w <Destroy> [list +DestroyChangeVar %W $w] ;# + to add to previous script
}

proc DestroyChangeVar { W w } {
    if { $W != $w } return
    global ChangeVarInfo
    array unset ChangeVarInfo ;#destroy also traces    
}

#----------------------ChangeVariables ALONE---------------------------
# if { $ChangeVariablesRunningAlone == 1 } {
#     ChangeVariables
# } 
#-----------------------------------------------------------------


