if {[catch {package require Tcl 8.5}]} return
set script ""
#if {![info exists ::env(TREECTRL_LIBRARY)]
#    && [file exists [file join $dir treectrl.tcl]]} {
    append script "set ::treectrl_library \"$dir\"\n"
#}

set sufijo ""
if { [ info exists ::tcl_platform(debug)]} {
    set sufijo "d"
}
if { "$::tcl_platform(machine)" == "amd64"} {
    #treectrl225_64.dll bad because provide 2.2.1 version, not 2.2.5, and treectrl225_64d.dll crash !!
    #it would be better if this dll was compiled with stubs, avoiding dependencies of Tcl and Tk dlls
    append script "load \"[file join $dir treectrl221_64.dll]\" treectrl"
    package ifneeded treectrl 2.2.1 $script
} else {
    append script "load \"[file join $dir treectrl225_32${sufijo}.dll]\" treectrl"
    package ifneeded treectrl 2.2.5 $script
}







